﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinEditors;
using Infragistics.Win.UltraWinToolbars;
using Infragistics.Win.Misc;
using Infragistics.Win;

namespace RibbonTest
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            
        }

        public void CreateSearch()
        {
            //Maybe this is the problem causing the flickering?
            BeginInvoke(new MethodInvoker(delegate()
            {
                RibbonTab tab = null;
                string searchTabKey = "Action";
                string InstanceName = "Test";

                if (!ribbonToolbarManager.Ribbon.Tabs.Exists(searchTabKey))
                {
                    tab = ribbonToolbarManager.Ribbon.Tabs.Add(searchTabKey);
                    tab.Caption = "Search";

                    ContextualTabGroup tabGroup = null;

                    if (!ribbonToolbarManager.Ribbon.ContextualTabGroups.Exists(InstanceName))
                    {
                        tabGroup = new ContextualTabGroup(InstanceName);
                        ribbonToolbarManager.Ribbon.ContextualTabGroups.Add(tabGroup);
                    }
                    else
                    {
                        tabGroup = ribbonToolbarManager.Ribbon.ContextualTabGroups[InstanceName];
                    }

                    tabGroup.Caption = "Function";
                    tabGroup.CaptionAppearance.TextHAlign = HAlign.Center;
                    tabGroup.Visible = true;
                    tab.ContextualTabGroup = tabGroup;

                    string searchParamsContainerKey = "";

                    for (int i = 0; i < 3; i++)
                    {
                        RibbonGroup parameterGroup = tab.Groups.Add("tabGroup" + i.ToString());
                        parameterGroup.LayoutDirection = RibbonGroupToolLayoutDirection.Vertical;
                        parameterGroup.LayoutAlignment = RibbonGroupLayoutAlignment.Far;
                        parameterGroup.PreferredToolSize = RibbonToolSize.Normal;
                        parameterGroup.Caption = "Test";

                        TableLayoutPanel pnlSearch = CreateSearchPanel();

                        ControlContainerTool cntrlSearch = null;

                        searchParamsContainerKey = InstanceName + "|" + "TestingThis" + i.ToString();

                        if (ribbonToolbarManager.Tools.Exists(searchParamsContainerKey))
                        {
                            ribbonToolbarManager.Tools.Remove(ribbonToolbarManager.Tools[searchParamsContainerKey]);
                        }

                        cntrlSearch = new ControlContainerTool(searchParamsContainerKey);
                        cntrlSearch.Control = pnlSearch;

                        ribbonToolbarManager.Tools.Add(cntrlSearch);
                        parameterGroup.Tools.AddTool(searchParamsContainerKey);
                        parameterGroup.Settings.CanCollapse = DefaultableBoolean.False;
                        pnlSearch.Parent = null;

                    }

                    string searchParamsAdvancedKey = InstanceName + "|AdvancedSearch";

                    RibbonGroup advancedGroup = tab.Groups.Add(searchParamsAdvancedKey += "|RibbonGroup");
                    advancedGroup.LayoutDirection = RibbonGroupToolLayoutDirection.Horizontal;
                    advancedGroup.PreferredToolSize = RibbonToolSize.Large;
                    advancedGroup.Settings.CanCollapse = DefaultableBoolean.False;
                    advancedGroup.Caption = "Advanced";
                    PopupControlContainerTool pt = new PopupControlContainerTool(searchParamsAdvancedKey);
                    pt.SharedProps.Caption = "Advanced";
                    pt.SharedProps.AppearancesSmall.Appearance.Image = null;
                    pt.Control = CreateAdvancedSearchPanel();
                    ribbonToolbarManager.Tools.Add(pt);
                    ToolBase ptBase = advancedGroup.Tools.AddTool(searchParamsAdvancedKey);


                    RibbonGroup groupSearch = tab.Groups.Add("Search");
                    groupSearch.LayoutDirection = RibbonGroupToolLayoutDirection.Horizontal;
                    groupSearch.PreferredToolSize = RibbonToolSize.Large;
                    groupSearch.Settings.CanCollapse = DefaultableBoolean.False;
                    //ToolBase searchButton = groupSearch.Tools.AddTool("SearchButton");
                    //ToolBase clearButton = groupSearch.Tools.AddTool("ClearButton");
                }
                else
                {
                    tab = ribbonToolbarManager.Ribbon.Tabs[searchTabKey];
                }

                ribbonToolbarManager.EndUpdate();
                ResumeLayout();
            }));
        }

        public TableLayoutPanel CreateSearchPanel()
        {
            int numberOfSearchParameters = 6;
            int numCols = numberOfSearchParameters / 3;
            int remainder = numberOfSearchParameters % 3;

            if (remainder != 0 && numberOfSearchParameters > 3)
                numCols += 1;

            TableLayoutPanel searchPanel = new TableLayoutPanel();
            searchPanel.SuspendLayout();

            searchPanel.RowCount = 3;
            searchPanel.Dock = DockStyle.Fill;
            searchPanel.AutoSize = true; //this fucks up with infragistics when set to true..posted a message on the forum..
            searchPanel.ColumnCount = numCols * 2;
            searchPanel.Name = "pnlParams";

            //now this is anal..spent too much time on this fucker..over here we have to manually figure out the width of the panel..cause if we have it on autosize infragistics controls fuck it up when in the controlcontainertool..
            //int panelWidth = GetPanelWith(searchDetail);

            //searchPanel.Size = new Size(panelWidth, 70);

            //TODO: if we change the appearance if we bound everything to default...this background colour might cause an issue..transparent layout panel causes flicker so needed to do quickfix...
            searchPanel.BackColor = Infragistics.Win.Office2007ColorTable.Colors.ContextualTabClientAreaGradientDark;

            if (searchPanel.ColumnCount > 0)
            {
                float ColumnSizePercent = 100 / searchPanel.ColumnCount;

                for (int i = 1; i <= searchPanel.ColumnCount; i++)
                {
                    searchPanel.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(SizeType.AutoSize));
                }
            }

            for (int i = 1; i <= 3; i++)
            {
                searchPanel.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 33.33333F));
            }

            int idx = 0;
            int column = 0;
            int row = 0;
            bool rangeInserted = false;


            for (int i = 0; i < 6; i++ )
            {

                UltraLabel lbl = new UltraLabel();
                lbl.Dock = DockStyle.Fill;
                lbl.AutoSize = true;
                lbl.Appearance.TextHAlign = Infragistics.Win.HAlign.Right;
                lbl.Appearance.TextVAlign = Infragistics.Win.VAlign.Middle;


                lbl.Text = "Testing";

                searchPanel.Controls.Add(lbl, column, row);

                Control cntrl = new UltraTextEditor() as Control;

                cntrl.Size = new Size(165, 21);

                searchPanel.Controls.Add(cntrl, column + 1, row);

                if (row == 2)
                {
                    column += 2;
                    row = 0;
                }
                else
                {
                    row += 1;
                }

                idx += 1;
            }

            searchPanel.ResumeLayout();
            return searchPanel;
        }

        public TableLayoutPanel CreateAdvancedSearchPanel()
        {
            int numberOfAdvancedParameters = 5;
            Padding zeroPadding = new Padding(0, 1, 0, 1);
            Size size = new Size(162, 21 * numberOfAdvancedParameters);

            TableLayoutPanel tlp = new TableLayoutPanel();
            tlp.SuspendLayout();
            tlp.Size = size;
            tlp.ColumnCount = 2;
            tlp.AutoSize = true;
            tlp.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(SizeType.AutoSize));
            tlp.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(SizeType.AutoSize));

            tlp.RowCount = numberOfAdvancedParameters;

            float rowHeight = 100F / tlp.RowCount;

            for (int i = 1; i <= tlp.RowCount; i++)
            {
                tlp.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.AutoSize, 21F));
            }


            int row = 0;


            for(int i = 0; i < 6; i++)
            {
                UltraLabel lbl = new UltraLabel();
                lbl.Dock = DockStyle.Fill;
                lbl.AutoSize = true;
                lbl.Appearance.TextHAlign = Infragistics.Win.HAlign.Right;
                lbl.Appearance.TextVAlign = Infragistics.Win.VAlign.Middle;
                lbl.Size = new Size(162, 22);
                lbl.Text = "Testing";
                lbl.Margin = zeroPadding;

                tlp.Controls.Add(lbl, 0, row);

                Control cntrl = new UltraTextEditor() as Control;
                cntrl.Size = new Size(162, 22);
                cntrl.Margin = zeroPadding;

                tlp.Controls.Add(cntrl, 1, row);

                row += 1;

            }

            tlp.ResumeLayout();
            return tlp;

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            CreateSearch();
        }
    }
}
